

/* Includes */
#include "main.h"

//flags
#define FLAG0 0
#define FLAG1 1
#define FLAG_RTC_SEC 2

#define SETBIT(AllBits, BITPOS)		(AllBits |=(1<<BITPOS))
#define CLEARBIT(AllBits, BITPOS)	(AllBits &=~ (1<<BITPOS))
#define TOGGLEBIT(AllBits, BITPOS)	CHECKBIT(AllBits, BITPOS)?CLEARBIT(AllBits, BITPOS):SETBIT(AllBits, BITPOS)

#define CHECKBIT(AllBits, BITPOS)	(AllBits & (1<<BITPOS))



#define DIPS_SIGN_DOT1 disp_sign[0]
#define DIPS_SIGN_DOT2 disp_sign[1]
#define DIPS_SIGN_DOT3 disp_sign[2]

#define TL_PIN	0  //PA0 kit
#define tlac (TL_GPIO->IDR & (1<< TL_PIN))


/* Private typedef */
typedef struct time_struct
{
	char						sec;
	char						min;
	char						hour;

} time_struct;
/* Private define  */

/* Private macro */
/* Private variables */
char status_flags;
time_struct rtc_time;

RU_PT6315_sign_control_struct disp_sign[3];

 USART_InitTypeDef USART_InitStructure;

/* Private function prototypes */
 void RTC_init(void);
/* Private functions */

/**
**===========================================================================
**
**  Abstract: main program

**
**===========================================================================
*/

 /* My address */
 uint8_t MyAddress[] = {
     0xE7,
     0xE7,
     0xE7,
     0xE7,
     0xE7
 };
 /* Receiver address */
 uint8_t TxAddress[] = {
     0x7E,
     0x7E,
     0x7E,
     0x7E,
     0x7E
 };

int main(void)
{
  DIPS_SIGN_DOT1.digit=0x05;
  DIPS_SIGN_DOT1.segment_combination=0x02;
  DIPS_SIGN_DOT1.sign_control=RU_PT6315_sign_off;

  DIPS_SIGN_DOT2.digit=0x00;
  DIPS_SIGN_DOT2.segment_combination=0x02;
  DIPS_SIGN_DOT2.sign_control=RU_PT6315_sign_off;

  DIPS_SIGN_DOT3.digit=0x01;
  DIPS_SIGN_DOT3.segment_combination=0x0F;
  DIPS_SIGN_DOT3.sign_control=RU_PT6315_sign_off;

  TM_DELAY_Init();
  RTC_init();

  RU_PT6315_init(RU_PT6315_display_mode_11_dig_17_seg);
  RU_PT6315_display_control(RU_PT6315_display_ON, 4);

  char temp_char_arr[10];

  SETBIT (status_flags, FLAG0);

  //RU_PT6315_put_chars("VERONIKA", 1);

  rtc_time.sec=20;
  rtc_time.min=14;
  rtc_time.hour=0;

  int i = 0;


  /**
  *  IMPORTANT NOTE!
  *  The symbol VECT_TAB_SRAM needs to be defined when building the project
  *  if code has been located to RAM and interrupts are used. 
  *  Otherwise the interrupt table located in flash will be used.
  *  See also the <system_*.c> file and how the SystemInit() function updates 
  *  SCB->VTOR register.  
  *  E.g.  SCB->VTOR = 0x20000000;  
  */


  /* go trough all segment*/
  /*
  	   for (digit = 0; digit < 11; ++digit)
  	  {
  	      for (seg = 0; seg < 18; ++seg)
  	      	{
  	      	    RU_PT6315_set_digit(1<<seg, digit);
  	      	    Delayms(100);
  	      	}

  	  }

   */
  CLEARBIT(status_flags, FLAG_RTC_SEC);
  CLEARBIT(status_flags, FLAG0);

  /* Infinite loop */
  while (1)
  {
	i++;
	if (CHECKBIT(status_flags, FLAG_RTC_SEC))
	{
	    CLEARBIT(status_flags, FLAG_RTC_SEC);

	    // RTC
	    rtc_time.sec++;
	    if (rtc_time.sec==60)
	    {
		rtc_time.sec=0;
		rtc_time.min++;
		if (rtc_time.min==60)
		  {
		    rtc_time.min=0;
		    rtc_time.hour++;

		    if (rtc_time.hour==24)
		      {
			rtc_time.hour=0;
		      }
		  }
	    }

	    ru_its_HrMnSc(rtc_time.hour, rtc_time.min, rtc_time.sec,temp_char_arr);

	    TOGGLEBIT(status_flags, FLAG0);

	    if (CHECKBIT(status_flags, FLAG0))
	    {
		DIPS_SIGN_DOT3.sign_control=RU_PT6315_sign_off;
		DIPS_SIGN_DOT1.sign_control=RU_PT6315_sign_off;
		DIPS_SIGN_DOT2.sign_control=RU_PT6315_sign_off;
	    }
	    else
	    {
		DIPS_SIGN_DOT3.sign_control=RU_PT6315_sign_on;
		DIPS_SIGN_DOT1.sign_control=RU_PT6315_sign_on;
		DIPS_SIGN_DOT2.sign_control=RU_PT6315_sign_on;
	    }

	    //RU_PT6315_put_chars(temp_char_arr, 1);

	    RU_PT6315_put_chars_with_signs(temp_char_arr, 2,disp_sign,3);

	}


#ifdef USE_LED
	STM_EVAL_LEDToggle(LED1);

#elif defined USE_STM32_DISCOVERY
    if(0 == STM32vldiscovery_PBGetState(BUTTON_USER))
    {
      /* Toggle LED3 */
      STM32vldiscovery_LEDToggle(LED3);
      /* Turn Off LED4 */
      STM32vldiscovery_LEDOff(LED4);
    }
    else
    {
      /* Toggle LED4 */
        STM32vldiscovery_LEDToggle(LED4);
      /* Turn Off LED3 */
      STM32vldiscovery_LEDOff(LED3);
    }
#endif
  }
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*
 * Minimal __assert_func used by the assert() macro
 * */
void __assert_func(const char *file, int line, const char *func, const char *failedexpr)
{
  while(1)
  {}
}

/*
 * Minimal __assert() uses __assert__func()
 * */
void __assert(const char *file, int line, const char *failedexpr)
{
   __assert_func (file, line, NULL, failedexpr);
}

#ifdef USE_SEE
#ifndef USE_DEFAULT_TIMEOUT_CALLBACK
/**
  * @brief  Basic management of the timeout situation.
  * @param  None.
  * @retval sEE_FAIL.
  */
uint32_t sEE_TIMEOUT_UserCallback(void)
{
  /* Return with error code */
  return sEE_FAIL;
}
#endif
#endif /* USE_SEE */

void RTC_init(void)
{
  /* Set interrupt */

  NVIC_InitTypeDef NVIC_InitStructure;

  /* Set the RTC_IRQn global Interrupt */

  NVIC_InitStructure.NVIC_IRQChannel = RTC_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* Set RTC */

  // Enable clock
   RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);

   // Enable acces to BKP
   PWR_BackupAccessCmd(ENABLE);

   // Register reset
   BKP_DeInit();

   // RTC clock from HSE/128 = 62.5 kHz!
   // RCC_RTCCLKConfig(RCC_RTCCLKSource_HSE_Div128);

   // RTC clock from internal osc
   // RCC_RTCCLKConfig(RCC_RTCCLKSource_LSI);

   // RTC clock from external osc 32 KHz
   // Enable LSE osc
   RCC_LSEConfig(RCC_LSE_ON);

   // Wait for LSE start
   while (RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET);

   // Assign LCE osc to clock
   RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);

   // enable RTC clock
   RCC_RTCCLKCmd(ENABLE);
   RTC_WaitForSynchro();
   // Waiting from write command execute
   RTC_WaitForLastTask();

   RTC_ITConfig(RTC_IT_SEC, ENABLE);
   //RTC_ITConfig(RTC_IT_ALR, ENABLE);
   // Waiting from write command execute
   RTC_WaitForLastTask();

   // prescaler setting
   //RTC_SetPrescaler(62499); // pro HSE
   RTC_SetPrescaler(32767); // pro LSE
   // Waiting from write command execute
   RTC_WaitForLastTask();

   // Clear reset flags
   RCC_ClearFlag();

}

void RTC_IRQHandler(void)
{
  if(RTC->CRL & RTC_CRL_SECF) //Second flag set
     {
      RTC->CRL &=~RTC_CRL_SECF; //clear SECF flag
      RTC_WaitForLastTask();
      SETBIT(status_flags, FLAG_RTC_SEC);
     }

}





