/**
 * |----------------------------------------------------------------------
 * | Copyright (C) Radoslav Uhrin, 2015
 * |
 * |----------------------------------------------------------------------
 */
#include "ru_int_to_string.h"

/* Private */
void ru_its_rever(char input_string[]);

extern void ru_its_itoa(int input_int, char output_buffer[])
{
    int i;
    unsigned char sign;

    if ((sign = input_int) < 0)  /* record sign */
        input_int = -input_int;          /* make n positive */

    i = 0;
    do {       /* generate digits in reverse order */
        output_buffer[i++] = input_int % 10 + '0';   /* get next digit */
    } while ((input_int /= 10) > 0);     /* delete it */

    if (sign < 0) /* add sign */
        output_buffer[i++] = '-';

    output_buffer[i] = '\0';
    ru_its_rever(output_buffer);
}

/**
  * @brief  Reverse string
  * @param  input_string = string
  * @retval : None
  */
void ru_its_rever(char output_buffer[])
{
    int i, j;
    char c;

    for (i = 0, j = strlen(output_buffer)-1; i<j; i++, j--) {
        c = output_buffer[i];
        output_buffer[i] = output_buffer[j];
        output_buffer[j] = c;
    }
}

extern void ru_its_xx_x(int input_int,char output_buffer[])
{
    ru_its_itoa( input_int, output_buffer);

if ((input_int<=999) && (input_int>99)) /*100-999*/
{
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[2];
 output_buffer[2]='.';
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[1];
 output_buffer[2]='.';
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[0];
 output_buffer[2]='.';
 output_buffer[1]='0';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]=' ';
 }

}



extern void ru_its_sig_sxx_x(int input_int,char output_buffer[])
{
 unsigned sig=0;

 if (input_int<0)
 {
   sig=1;
   input_int=-input_int;
 }
    ru_its_itoa( input_int, output_buffer);

if ((input_int<=999) && (input_int>99)) /*100-999*/
{
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[2];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[1];
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=(sig) ? ('-') : (' ');
}

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[1];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[0];
 output_buffer[1]=(sig) ? ('-') : (' ');
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[0];
 output_buffer[3]='.';
 output_buffer[2]='0';
 output_buffer[1]=(sig) ? ('-') : (' ');
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]='-';
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]=(sig) ? ('-') : (' ');
 output_buffer[0]=' ';
 }
}

extern void ru_its_xx_x_d10(int input_int,char output_buffer[])
{
    ru_its_itoa( input_int, output_buffer);

    if ((input_int<=9999) && (input_int>999)) /*1000-9999*/
{
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[2];
 output_buffer[2]='.';
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[1];
 output_buffer[2]='.';
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=' ';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[0];
 output_buffer[2]='.';
 output_buffer[1]='0';
 output_buffer[0]=' ';
 }

 else if (input_int<=9) /*0-9*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='0';
 output_buffer[2]='.';
 output_buffer[1]='0';
 output_buffer[0]=' ';
 }

 else
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]=' ';
 }
}

extern void ru_its_x_xx(int input_int,char output_buffer[])
{
    ru_its_itoa( input_int, output_buffer);

if ((input_int<=999) && (input_int>99)) /*100-999*/
{
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[2];
 output_buffer[2]=output_buffer[1];
 output_buffer[1]='.';
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[1];
 output_buffer[2]=output_buffer[0];
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[0];
 output_buffer[2]='0';
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

 else /*>999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}

extern void ru_its_x_xx_d10(int input_int,char output_buffer[])
{
    ru_its_itoa( input_int, output_buffer);

    if ((input_int<=9999) && (input_int>999)) /*1000-9999*/
{
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[2];
 output_buffer[2]=output_buffer[1];
 output_buffer[1]='.';
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[1];
 output_buffer[2]=output_buffer[0];
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[0];
 output_buffer[2]='0';
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

 else if (input_int<=9) /*0-9*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='0';
 output_buffer[2]='0';
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

 else
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}

extern void ru_its_x_xxx(int input_int,char output_buffer[])
{
 ru_its_itoa( input_int, output_buffer);

if ((input_int<=9999) && (input_int>999)) /*1000-9999*/
{

 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[3];
 output_buffer[3]=output_buffer[2];
 output_buffer[2]=output_buffer[1];
 output_buffer[1]='.';
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[2];
 output_buffer[3]=output_buffer[1];
 output_buffer[2]=output_buffer[0];
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[1];
 output_buffer[3]=output_buffer[0];
 output_buffer[2]='0';
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[0];
 output_buffer[3]='0';
 output_buffer[2]='0';
 output_buffer[1]='.';
 output_buffer[0]='0';
 }

 else /*>999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]='-';
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}

extern void ru_its_xx_xx(int input_int,char output_buffer[])
{
 ru_its_itoa( input_int, output_buffer);

if ((input_int<=9999) && (input_int>999)) /*1000-9999*/
{

 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[3];
 output_buffer[3]=output_buffer[2];
 output_buffer[2]='.';
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[2];
 output_buffer[3]=output_buffer[1];
 output_buffer[2]='.';
 output_buffer[1]=output_buffer[0];
 output_buffer[0]='0';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[1];
 output_buffer[3]=output_buffer[0];
 output_buffer[2]='.';
 output_buffer[1]='0';
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[0];
 output_buffer[3]='0';
 output_buffer[2]='.';
 output_buffer[1]='0';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]='-';
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}

extern void ru_its_xxx_x(int input_int,char output_buffer[])
{
 ru_its_itoa( input_int, output_buffer);

if ((input_int<=9999) && (input_int>999)) /*1000-9999*/
{

 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[3];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[2];
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[2];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[1];
 output_buffer[1]=output_buffer[0];
 output_buffer[0]='0';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[1];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[0];
 output_buffer[1]='0';
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[0];
 output_buffer[3]='.';
 output_buffer[2]='0';
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]='-';
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}

extern void ru_its_xxx(int input_int,char output_buffer[])
{
    ru_its_itoa( input_int, output_buffer);

if ((input_int<=999) && (input_int>99)) /*100-999*/
{
 output_buffer[3]='\0'; //end sign
 output_buffer[2]=output_buffer[2];
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[3]='\0'; //end sign
 output_buffer[2]=output_buffer[1];
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[3]='\0'; //end sign
 output_buffer[2]=output_buffer[0];
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[3]='\0'; //end sign
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}

extern void ru_its_sig_sxxx(int input_int,char output_buffer[])
{
 unsigned sig=0;

 if (input_int<0)
 {
   sig=1;
   input_int=-input_int;
 }
    ru_its_itoa( input_int, output_buffer);

if ((input_int<=999) && (input_int>99)) /*100-999*/
{
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[2];
 output_buffer[2]=output_buffer[1];
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=(sig) ? ('-') : (' ');
}

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[1];
 output_buffer[2]=output_buffer[0];
 output_buffer[1]=(sig) ? ('-') : (' ');
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[0];
 output_buffer[2]=(sig) ? ('-') : (' ');
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}


extern void ru_its_xxxx(int input_int,char output_buffer[])
{
 ru_its_itoa( input_int, output_buffer);

if ((input_int<=9999) && (input_int>999)) /*1000-9999*/
{

 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[3];
 output_buffer[2]=output_buffer[2];
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[2];
 output_buffer[2]=output_buffer[1];
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=' ';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[1];
 output_buffer[2]=output_buffer[0];
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]=output_buffer[0];
 output_buffer[2]=' ';
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }

}

extern void ru_its_xxxxx(int input_int,char output_buffer[])
{
 ru_its_itoa( input_int, output_buffer);

if ((input_int<=99999) && (input_int>9999)) /*10000-99999*/
{
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[4];
 output_buffer[3]=output_buffer[3];
 output_buffer[2]=output_buffer[2];
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=9999) && (input_int>999)) /*1000-99999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[3];
 output_buffer[3]=output_buffer[2];
 output_buffer[2]=output_buffer[1];
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=' ';
 }

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[2];
 output_buffer[3]=output_buffer[1];
 output_buffer[2]=output_buffer[0];
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[1];
 output_buffer[3]=output_buffer[0];
 output_buffer[2]=' ';
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[5]='\0'; //end sign
 output_buffer[4]=output_buffer[0];
 output_buffer[3]=' ';
 output_buffer[2]=' ';
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[4]='\0'; //end sign
 output_buffer[4]='-'; //end sign
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }
}

extern void ru_its_xxx_xx(int input_int,char output_buffer[])
{
 ru_its_itoa( input_int, output_buffer);

if ((input_int<=99999) && (input_int>9999)) /*10000-99999*/
{
 output_buffer[6]='\0'; //end sign
 output_buffer[5]=output_buffer[4];
 output_buffer[4]=output_buffer[3];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[2];
 output_buffer[1]=output_buffer[1];
 output_buffer[0]=output_buffer[0];
}

else if ((input_int<=9999) && (input_int>999)) /*1000-99999*/
 {
 output_buffer[6]='\0'; //end sign
 output_buffer[5]=output_buffer[3];
 output_buffer[4]=output_buffer[2];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[1];
 output_buffer[1]=output_buffer[0];
 output_buffer[0]=' ';
 }

else if ((input_int<=999) && (input_int>99)) /*100-999*/
 {
 output_buffer[6]='\0'; //end sign
 output_buffer[5]=output_buffer[2];
 output_buffer[4]=output_buffer[1];
 output_buffer[3]='.';
 output_buffer[2]=output_buffer[0];
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

else if ((input_int<=99) && (input_int>9)) /*10-99*/
 {
 output_buffer[6]='\0'; //end sign
 output_buffer[5]=output_buffer[2];
 output_buffer[4]=output_buffer[1];
 output_buffer[3]='.';
 output_buffer[2]='0';
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

else if (input_int<=9) /*0-9*/
 {
 output_buffer[6]='\0'; //end sign
 output_buffer[5]=output_buffer[1];
 output_buffer[4]='0';
 output_buffer[3]='.';
 output_buffer[2]='0';
 output_buffer[1]=' ';
 output_buffer[0]=' ';
 }

 else /*>999*/
 {
 output_buffer[6]='\0'; //end sign
 output_buffer[5]='-'; //end sign
 output_buffer[4]='-';
 output_buffer[3]='-';
 output_buffer[2]='-';
 output_buffer[1]='-';
 output_buffer[0]='-';
 }
}

extern void ru_its_HrMnSc(char hour, char min, char sec,char output_buffer[])
{
  char temp_buffer[3];

  ru_its_itoa( sec, temp_buffer);
  if (sec<10)
  {
   output_buffer[5]=temp_buffer[0];
   output_buffer[4]='0';
  }
  else
  {
   output_buffer[5]=temp_buffer[1];
   output_buffer[4]=temp_buffer[0];
  }

  ru_its_itoa( min, temp_buffer);
  if (min<10)
  {
   output_buffer[3]=temp_buffer[0];
   output_buffer[2]='0';
  }
  else
  {
   output_buffer[3]=temp_buffer[1];
   output_buffer[2]=temp_buffer[0];
  }

  ru_its_itoa( hour, temp_buffer);
  if (hour<10)
  {
   output_buffer[1]=temp_buffer[0];
   output_buffer[0]=' ';
  }
  else
  {
   output_buffer[1]=temp_buffer[1];
   output_buffer[0]=temp_buffer[0];
  }

  output_buffer[7]='\0'; //end sign
}

