/**
 *	conversion int value to string for LCD display
 *
 *	@author 	Radoslav Uhrin
 *	@email
 *	@website
 *	@link
 *	@version 	v1.0
 *	@license	GNU GPL v3
 *
 * |----------------------------------------------------------------------
 * | Copyright (C) Radoslav Uhrin, 2015
 * |
 * |----------------------------------------------------------------------
 */

#ifndef RU_INT_TO_STRING
#define RU_INT_TO_STRING 100
/**
 * Dependencies
 * 	- string.h
 */
/**
 * Includes
 */


#include <string.h>

/**
  * @brief  Basic conversion Integer to String
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_itoa(int input_int,char output_buffer[]);


/**
  * @brief  Format conversion x.xx (max 999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_x_xx(int input_int,char output_buffer[]);


/**
  * @brief  Format conversion x.xx (max 999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xx_x(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion (-)x.xx (max 999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_sig_sxx_x(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion x.xxx (max 9999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_x_xxx(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion xx.xx (max 9999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xx_xx(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion xxx.x (max 9999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xxx_x(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion xxx (max 999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xxx(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion (-)xxx (max 999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_sig_sxxx(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion xxxx (max 9999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xxxx(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion xxxxx (max 99999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xxxxx(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion xxx_xx (max 99999)
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xxx_xx(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion xx.x (max 9999) divide 10!
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_xx_x_d10(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion x.xx (max 9999) divide 10!
  * @param  input_int = input integer, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_x_xx_d10(int input_int,char output_buffer[]);

/**
  * @brief  Format conversion rtc to format HourMinsec without separator string
  * @param  input_char hour,min, sec, output_buffer = output buffer
  * @retval : None
  */

extern void ru_its_HrMnSc(char hour, char min, char sec,char output_buffer[]);


#endif

